﻿import ntpath
import os
import subprocess
from subprocess import Popen, PIPE
import string


console.show()
console.clear()
#console.write("Preparing package!\r\n") 

notepad.save()

full_filename = notepad.getCurrentFilename()
short_path = ntpath.dirname (full_filename)
filename = ntpath.basename(full_filename)
short_filename = filename.split('.')[0]
console.write("\r\nHello\r\n") 
	
if len(filename.split('.'))>1:
	extension = filename.split('.')[1]
else:
	extension = 'err'
	
if  extension.upper() == 'PY':
	console.write("\r\nMaking skeleton...\r\n") 

	notepad.new("main");
	#notepad.activateFile("main")
	editor.setCodePage(65001)
	editor.appendText("#! /bin/bash\n"); 
	editor.appendText('cd "$(dirname "${0}")"\n');
	editor.appendText('TIFS=$IFS\n');
	editor.appendText("IFS='"'&'"'\n");
	editor.appendText('OPTIONS=($QUERY_STRING)\n');
	editor.appendText('IFS=$TIFS\n');	
	editor.appendText("tty="'"${1:-/dev/ttyUSB0}"'"\n")	
	editor.appendText("python -u %s ${OPTIONS[@]}\n" % short_filename);
	notepad.saveAs(short_path + '\main')
	notepad.close()

	
	os.system("copy %s %s\%s" % ('skeleton\main_orbi_start',short_path, short_filename))
	#start copied to short_filename
	outp = open("%s\%s"%(short_path, short_filename), "a")
	inp = open("%s\%s"%(short_path, filename), "r")
	outp.write (inp.read())
	#contents appended to short_filename (without ext)
	
	inp = open('skeleton\main_orbi_end', "r")	
	outp.write (inp.read())
	outp.close()
	inp.close()
	
	os.system("copy %s %s" % ('skeleton\\orbicraft.py',short_path + '\\orbicraft.py'))
	os.system("copy %s %s" % ('skeleton\\rediscan.py',short_path + '\\rediscan.py'))

	console.write("Skeleton Ok!\r\n") 

	notepad.activateFile(full_filename)
		
	console.write('\r\nStarting ZIP\r\n')
	console.write('7zip\\7za.exe a %s\%s.zip %s\%s %s\\main %s\\orbicraft.py %s\\rediscan.py\r\n'%(short_path, short_filename, short_path, short_filename, short_path, short_path, short_path))
	p = Popen('7zip\\7za.exe a %s\%s.zip %s\%s %s\\main %s\\orbicraft.py %s\\rediscan.py'%(short_path, short_filename, short_path, short_filename, short_path, short_path, short_path), stdout=PIPE, stderr=PIPE, shell=True)
	p.wait
	res = p.communicate()
	errorCode=p.returncode
	
	if errorCode <> 0:
		console.write("ZIP Error!\r\n")
		console.write(res[1]);
	else:
		console.write("ZIP Ok!\r\n")
		
		console.write("\r\nCleaning\r\n")
		
		os.remove(short_path + '\main')
		os.remove('main')
		os.remove("%s\%s"%(short_path, short_filename))
		os.remove("%s\\orbicraft.py"%(short_path))
		os.remove("%s\\rediscan.py"%(short_path))
        
else:
	console.write("Unknown extension\r\n")